//
// Adapted by Nick Rapallo (January 2008)
//
// Modified code taken directly from "SBPubX.doc" (installed by the eBook Publisher
// software).  Given a single .html it creates .opf project file for later use as well
// as .IMP for REB 1200; can change the latter to GEB/EBW 1150 or REB 1100 by
// uncommenting the {BuildTarget} lines below.

//Variables
var fileName="";
var sDirName="";
var szBaseNameNoExt;
var szCommand;
var szAuthor = "Uknown";
var fnFile;

/* Create WSH Shell */
var oShell = WScript.CreateObject( "WScript.Shell" );
var oArgs  = WScript.Arguments;

var oFSO   		= new ActiveXObject("Scripting.FileSystemObject");
var oProject	= WScript.CreateObject("SBPublisher.Project");
var oBuilder 	= WScript.CreateObject("SBPublisher.Builder", "ev_oBuilder_");
//var fnFile 		= oFSO.CreateTextFile("C:\\out.txt",true);

WScript.Echo("Count " + oArgs.count());
if(oArgs.count()>=3){
   fileFullPathName = oArgs.item(3);
   sDirName = dirname(oArgs.item(3));
   fileName = basename(oArgs.item(3));
   szBaseNameNoExt = removeExt(fileName, '.html');
}
else{
   WScript.Echo("Html2imp.pl Authorname Title Category htmlfilename.html");
   WScript.exit;
}

if (sDirName.length == 0){
	sDirName = oShell.CurrentDirectory;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Create a new project and add our document file with optional cover.
//
oProject.ClearAll();
oProject.AddSourceFile(oArgs.item(3));
 

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Set the various "metadata" items for the publication
//
oProject.AuthorFirstName = oArgs.item(0);
oProject.BookTitle       = oArgs.item(1);
oProject.Category        = oArgs.item(2);
//oProject.ISBN = oProject.CanonicalizeISBN("0448163004 ");
//oProject.BISAC = "FIC004000";

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Now build the OEBFF output
//
oProject.OutputDirectory = ".";
oProject.Compress        = 1;   //True
oProject.Encrypt         = 0;   //False
oProject.KeepAnchors     = 1;   //True
oProject.Language        = "en";
oProject.RequireISBN     = 0;   //False
oProject.Zoom            = 2;


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Now (optionally) build the EBW/GEB 1150 (gray HalfVga) .IMP output
//
//oProject.BookFileName    = oArgs.item(3);
oProject.BookFileName    = oArgs.item(0) + " - " + oArgs.item(1);
//oProject.Save(oArgs.item(3) . ".opf");
oProject.Save(oArgs.item(0) + " - " + oArgs.item(1) + ".opf");
//
oProject.BuildTarget = 2;
//
// Now generate both the OEBFF and/or .IMP output
//$builder.GenerateOEBFF(oProject, 1);
oBuilder.Build(oProject);


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Now (optionally) build the REB 1100 (mono HalfVGA) .RB output
//
//oProject.BookFileName    = oArgs.item(3);
//oProject.BookFileName    = oArgs.item(0) . " - " . oArgs.item(1);
//oProject.Save(oArgs.item(3) . ".opf");
//oProject.Save(oArgs.item(0) . " - " . oArgs.item(1) . ".opf");
//
//oProject.BuildTarget = 3;
//
// Now generate the .RB output

////////////////////////////////////////////////////////////////////////////////////
//
// Event Handlers
//

//function ev_OnBuildStart(project)
//{
//	project;
////	print "Beginning validation...\n";
//}


//sub OnError()
//{
//	// Get the arguments
//	my ($builder,
//		$filename, 
//		$msg, 
//		$line, 
//		$col, 
//		$severity, 
//		@args) = @_;
//
//	my @severities = ("NOTE", "FATAL ERROR", "ERROR", "WARNING");
//
//	if ($filename =~ m/^.+[\\|\/](.+?)$/) { $filename = $1; }
//
//	// Print out the error message including any NOTE feedback.
//	// To ignore Warnings, change below to: if ($severity < 3)
//	if ($severity >= 0)
//	{
//		printf(" %-15s (L:%6d, C:%6d) %-7s:",
//			$filename,
//			$line,
//			$col,
//			$severities[$severity]);
//
//		print " $msg\n";
//	}
//}


///////////// FUNCTIONS ///////////////////
function basename(path) {
    return path.replace(/\\/g,'/').replace( /.*\//, '' );
}
       
function dirname(path) {
	var reg = /(.*)(\\|\/)(.*)$/;
	var aMatch = path.split(/\\|\//);
    var dirPath = "";

	if (aMatch.length > 1){
		aMatch.pop();
		dirPath = aMatch.join("/");
	}
    return dirPath;
}

function removeExt(path,ext) {
    //We don't care about case
    var pathi = path
    pathi.toLowerCase();
    return path.substring(0, pathi.lastIndexOf(ext));
}
